//==========================================================================
// DirectXライブラリ[dxlib.h]
// author: tatuya ogawa
//==========================================================================
#ifndef _dxlib_h_
#define _dxlib_h_

//==========================================================================
// include
//==========================================================================
#include <Windows.h>
#include <direct.h>
#include <math.h>
#include <stdio.h>
#include <time.h>
#include <d3d9.h>
#include <d3dx9.h>
#include <XInput.h>
#include <XAudio2.h>
#include <codecvt> // c++ 文字コード変換
#include <cstdlib> // c++ 数値変換
#include <locale> // c++ 文字の判定
#include <system_error> // c++ OSエラー
#include <vector> // c++ 動的構造体
#include <list> // c++ 双方向list
#include <map> // c++ 平衡二分木 ソート機能付き
#include <unordered_map> // c++ 平衡二分木 ソート機能無し
#include <iomanip> // c++ 時間
#include <string> // c++ char
#include <random> // c++ rand
#include <fstream> // c++ file
#define DIRECTINPUT_VERSION (0x0800) // DirectInputのバージョン指定
#include <dinput.h>
#include <tchar.h>

//==========================================================================
// 独自lib include
//==========================================================================

//==========================================================================
// 継承用include
//==========================================================================
#include "Lib\Template.h"
//#include "Lib\ExcelOpen.h"
//#include "Lib\Rectangle.h"
#include "Lib\SetSampler.h"
//#include "Lib\Create.h"
//#include "Lib\SetRender.h"
//#include "Lib\Vertex3D.h"

//==========================================================================
// データ型include
//==========================================================================
#include "Lib\DataType.h"

//==========================================================================
// struct
//==========================================================================
#include "Lib\StructType.h"

//==========================================================================
// デバイスinclude
//==========================================================================
#include "Lib\DeviceManager.h"

//==========================================================================
// サウンド
//==========================================================================
#include "Lib\XAudio2.h"

//==========================================================================
// XInput
//==========================================================================
#include "Lib\XInput.h"

//==========================================================================
// 文字列include
//==========================================================================
#include "Lib\text.h"

//==========================================================================
// テクスチャ管理機能
//==========================================================================
//#include "Lib\TextureLoader.h"

//==========================================================================
// ヘルパークラスinclude
//==========================================================================
#include "Lib\HitDetermination.h"
#include "Lib\Timer.h"
#include "Lib\Number.h"
#include "Lib\Object.h"
#include "Lib\ObjectVectorManager.h"
#include "Lib\ObjectListManager.h"

//==========================================================================
// 座標クラスinclude
//==========================================================================
#include "Lib\2DObject.h"
#include "Lib\3DObject.h"

//==========================================================================
// 2D描画include
//==========================================================================
#include "Lib\2DPolygon.h"

//==========================================================================
// 3D描画include
//==========================================================================
#include "Lib\Billboard.h"
#include "Lib\Cube.h"
#include "Lib\Mesh.h"
#include "Lib\Shadow.h"
#include "Lib\Sphere.h"
#include "Lib\Model.h"

//==========================================================================
// グリッドinclude
//==========================================================================
#include "Lib\Grid.h"

//==========================================================================
// ライトinclude
//==========================================================================
#include "Lib\Light.h"

//==========================================================================
// カメラinclude
//==========================================================================
#include "Lib\Camera.h"

//==========================================================================
// ImGui
//==========================================================================
#include "Lib\ImGui_Dx9.h"

//==========================================================================
// Convert
//==========================================================================
#include "Lib\CharConvert.h"

//==========================================================================
// enum拡張機能
//==========================================================================
#include "Lib\enum_system.hpp"

#endif // !_dxlib_h_
